#ifndef REND_CUBEMAP_H_
#define REND_CUBEMAP_H_

#include "renderer.h"
#include "texture.h"

class RendCubemap : public Renderer {
private:
	Vec3 pos;
	Texture *cubemap;
	mutable unsigned int fbo, zbuf;
	mutable int zbuf_width, zbuf_height;
	Mat4 proj_matrix;

	void setup(int face_idx) const;

public:
	RendCubemap();

	void set_position(const Vec3 &pos);
	void set_cubemap(Texture *cubemap);

	void draw() const;
	void draw_object(Object *obj) const;
};

#endif	// REND_CUBEMAP_H_
